//  Memory_Helper.h
//
//  Galaxy Group
//  Minsk, Slavic Rus
//  https://www.councils.world/
//  Kozlov Sergey Aleksandrovitsch
//  Since 2025 year.

#include "Memory_Helper_Exports.h"

namespace Galaxy_Group_Star
{
	namespace Memory_Helper
	{
		const unsigned long Memory_Helper_Worker_Timer_Event_Delay = 1000 / 100;

		void _cdecl Memory_Helper_Worker_Thread_Function(void* lp);


		class Memory_Helper_Worker;

		class Memory_Helper_Worker_Thread_Function_Parameters
		{
		public:			
			Memory_Helper_Worker *memory_helper_worker;
		};

		class Memory_Helper_Worker
		{
		private:
			bool do_termanate;
			bool termanation_allowed;
			uintptr_t working_thread;

		protected:
			call_back_alarm_function_type *Call_Back_Alarm_Function;

			virtual void Check();

			virtual bool Is_Memory_Alarm_Occured();

			virtual bool Control_Memory();

		public:
			Memory_Helper_Worker();

			Memory_Helper_Worker(const Memory_Helper_Worker& p);

			Memory_Helper_Worker& operator=(const Memory_Helper_Worker& p);

			virtual ~Memory_Helper_Worker();

			virtual void Work();

			friend void _cdecl Memory_Helper_Worker_Thread_Function(void* lp);

			virtual void Terminate();

			virtual bool Get_Termanation_Allowed();

			virtual void Set_Call_Back_Alarm_Function(call_back_alarm_function_type* p);

		private:
			virtual void Do_Work();
		};
	}
}
