#pragma once

#include <list>
#include <memory>

#include "Memory_Helper_Exports.h"

template <class T>
void _cdecl Test_Button_Thread_Function(void* lp);

template<class T> 
class array_pointer
{
private:
    T* data;
    unsigned int size;

public:
    array_pointer(T* p, unsigned int p_size)
    {
        data = p;
        size = p_size;
    }

    array_pointer(const array_pointer& p)
    {
        size = 0;

        data = new T[p.size];
        
        if (data != nullptr)
        {
            size = p.size;

            memcpy(data, p.data, size * sizeof(T));
        }
    }

    array_pointer& operator=(const array_pointer& p)
    {
        size = 0;

        data = new T[p.size];

        if (data != nullptr)
        {
            memcpy(data, p.data, size * sizeof(T));

            size = p.size;
        }

        return *this;
    }

    ~array_pointer()
    {
        if (data != nullptr)
        {
            delete[] data;

            data = nullptr;
        }

        size = 0;
    }
};

template <class T>
class Test_Button;

template <class T>
class Test_Button_Thread_Function_Parameters
{
public:
    Test_Button<T>* test_button;
};

template <class T>
class Test_Button :
    public T
{
private:
    std::list<array_pointer<BYTE>> memory;
    uintptr_t working_thread;
public:
    Test_Button();

    Test_Button(const Test_Button<T>& p);

    Test_Button<T>& operator=(const Test_Button<T>& p);

    void Start_Test();
    void Stop_Test();

    friend void _cdecl Test_Button_Thread_Function<T>(void* lp);

protected:
    void Do_Test();

private:
    void Do_Work();

    entrance_function_type* ef;

    set_call_back_alarm_function_type* scbaf;

    terminate_memory_helper_function_type* tmhf;
};
