#include "pch.h"
#include "Test_Button.h"

#include <process.h>

extern "C" void call_back_alarm_function();

extern "C" bool test_button_stop_testing = false;

template <class T>
Test_Button<T>::Test_Button()
	: working_thread(0), ef(nullptr), scbaf(nullptr), tmhf(nullptr)
{
}

template <class T>
Test_Button<T>::Test_Button(const Test_Button& p)
{
	working_thread = p.working_thread;
	
	ef = p.ef;
	scbaf = p.scbaf;
	tmhf = p.tmhf;
}

template <class T>
Test_Button<T>& Test_Button<T>::operator=(const Test_Button<T>& p)
{
	working_thread = p.working_thread;

	ef = p.ef;
	scbaf = p.scbaf;
	tmhf = p.tmhf;

	return *this;
}

template <class T>
void Test_Button<T>::Start_Test()
{
	HMODULE Memory_Helper_Module = LoadLibraryW(L"Memory_Helper.dll");

	if (Memory_Helper_Module != nullptr)
	{
		ef = (entrance_function_type*)GetProcAddress(Memory_Helper_Module, "entrance");

		scbaf = (set_call_back_alarm_function_type*)GetProcAddress(Memory_Helper_Module, "set_call_back_alarm_function");

		tmhf = (terminate_memory_helper_function_type*)GetProcAddress(Memory_Helper_Module, "terminate_memory_helper");

		if (ef != nullptr && tmhf != nullptr && scbaf != nullptr)
		{

			EnableWindow(FALSE);

			ef();

			scbaf(&call_back_alarm_function);

			Do_Test();
		}
	}
}

template <class T>
void Test_Button<T>::Stop_Test()
{
	test_button_stop_testing = true;

	if (tmhf != nullptr)
	{
		tmhf();
	}
}

template <class T>
void Test_Button<T>::Do_Work()
{
	test_button_stop_testing = false;

	for (;!test_button_stop_testing;)
	{
		unsigned int n = 2000000;

		BYTE *array = new BYTE[n];

		memset(array, 0, sizeof(BYTE) * n);

		memory.push_back(array_pointer<BYTE>(array, n));

		Sleep(1);
	}

	EnableWindow(TRUE);
}

template <class T>
void Test_Button<T>::Do_Test()
{
	Test_Button_Thread_Function_Parameters<T>* p = new Test_Button_Thread_Function_Parameters<T>();

	if (p != nullptr)
	{
		p->test_button = this;
		working_thread = _beginthread(&Test_Button_Thread_Function<T>, 0, p);
	}
}

template <class T>
void _cdecl Test_Button_Thread_Function(void* lp)
{
	if (lp != nullptr)
	{
		Test_Button_Thread_Function_Parameters<T>* tbtfp = (Test_Button_Thread_Function_Parameters<T>*)(lp);

		if (tbtfp != nullptr)
		{
			Test_Button<T>* local_tb = tbtfp->test_button;

			if (local_tb != nullptr)
			{
				local_tb->Do_Work();

				local_tb->Stop_Test();
			}
		}

		delete lp;
	}
}

extern "C" void call_back_alarm_function()
{
	test_button_stop_testing = true;
	AfxMessageBox(L"call_back_alarm_function is called: test done well.\n", MB_ICONEXCLAMATION);
}
